package ru.dbotthepony.kstarbound.defs.monster

import com.google.common.collect.ImmutableList
import com.google.common.collect.ImmutableMap
import com.google.common.collect.ImmutableSet
import ru.dbotthepony.kstarbound.defs.AssetReference
import ru.dbotthepony.kstarbound.defs.DirectAssetReference
import ru.dbotthepony.kstarbound.defs.IScriptable
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.MovementParameters
import ru.dbotthepony.kstarbound.defs.RegistryReference
import ru.dbotthepony.kstarbound.defs.animation.AnimationDefinition
import ru.dbotthepony.kstarbound.defs.item.TreasurePoolDefinition
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class MonsterTypeDefinition(
	val type: String,
	override val shortdescription: String,
	override val description: String,
	val categories: ImmutableSet<String> = ImmutableSet.of(),
	val parts: ImmutableSet<String> = ImmutableSet.of(),
	val animation: AssetReference<AnimationDefinition>,
	// [ { "default" : "poptopTreasure", "bow" : "poptopHunting" } ],
	val dropPools: ImmutableList<ImmutableMap<String, RegistryReference<TreasurePoolDefinition>>>,
	val baseParameters: BaseParameters
) : IThingWithDescription {
	@JsonFactory
	data class BaseParameters(
		val movementSettings: MovementParameters? = null,
		override val scriptDelta: Int = 1,
		override val scripts: ImmutableList<DirectAssetReference>
	) : IScriptable
}
